<?php
/*
Plugin Name: Table2Chart
Plugin URI: http://www.antoniorinaldi.it/from-table-to-chart-in-wordpress/
Description: Draw a chart from a table using HighCharts JS library
Version: 0.3 BETA
Author: Antonio Rinaldi
Author URI: http://www.antoniorinaldi.it
*/

/*
Table2Chart (Wordpress Plugin)
Copyright (C) 2013 Antonio Rinaldi
Contact me at http://www.antoniorinaldi.it/from-table-to-chart-in-wordpress/
This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details. You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>.

IMPORTANT NOTE: The above statement does NOT substitute HighCharts terms of use. HighCharts use is free for a personal or non-profit project under the Creative Commons Attribution-NonCommercial 3.0 License. ANyWAY please refer to HighCharts license page http://shop.highsoft.com/highcharts.html to check the HighCharts precise license conditions.  
*/

T2Cc::setup();

class T2Cc {

public static function initialize() {
DEFINE("T2C_TABLE", "1");
DEFINE("T2C_TYPE", "column");
DEFINE("T2C_BACKGROUND", "#ffffff");
DEFINE("T2C_COLOR", "#ff0000,#00ff00,#0000ff,#00ffff,#ff00ff,#ffff00");
DEFINE("T2C_WIDTH", "500");
DEFINE("T2C_HEIGHT", "400");
DEFINE("T2C_ORDER", "column");
DEFINE("T2C_NAMECOL", "1");
DEFINE("T2C_NAMEROW", "1");
DEFINE("T2C_CONVERT", "true");
}

public static function setup() {
self::initialize();
//tell wordpress to register the T2C shortcode

add_shortcode("Table2Chart", array ( __CLASS__,"Table2Chart_handler"));
}
  
public static function Table2Chart_handler($incomingfrompost) {
	wp_enqueue_script("jquery");
	wp_enqueue_script("highcharts", ((file_exists(plugin_dir_path(__FILE__) .  "highcharts.js")) ? plugin_dir_url(__FILE__) : "//cdnjs.cloudflare.com/ajax/libs/highcharts/2.3.5/") . "highcharts.js" ,array("jquery"),null,false);
	wp_enqueue_script("Table2Chart", plugins_url( "table2chart.js", __FILE__ ),array("jquery","highcharts"),null,false);
	do_action('wp_footer', 'your_function');
	$incomingfrompost=shortcode_atts(array(
    "table" => T2C_TABLE,
    "type" => T2C_TYPE,
    "title" => "",
    "subtitle" => "",
    "titlex" => "",
    "titley" => "",
    "background" => T2C_BACKGROUND,
	"color" => T2C_COLOR,
    "width" => T2C_WIDTH,
    "height" => T2C_HEIGHT,          
    "order" => T2C_ORDER,
    "namecol" => T2C_NAMECOL,
    "namerow" => T2C_NAMEROW,
    "excludecols" => "",
    "excluderows" => "",
    "includecols" => "",
    "includerows" => "",
    "convert" => T2C_CONVERT            
  ), $incomingfrompost);
  //run function that actually does the work of the plugin
  static $T2C_prog;
  $rnd=mt_rand();
  $T2C = "";
  if (! $T2C_prog) $T2C_prog=0; 	
  $T2C_prog++;
  $T2C .="<div class=\"Table2Chart\" id=\"container-HC-" . $T2C_prog . "-" . $rnd . "\" style=\"width:" . esc_attr($incomingfrompost["width"]) . "px; height:" . esc_attr($incomingfrompost["height"]) . "px; margin: 0 auto 1em\"></div>\n<script id=\"script-container-HC-"  . $T2C_prog . "-" . $rnd . "\" type=\"application/json\">";
    $T2C .= '{';
  $T2C .='"table":' . ($incomingfrompost["table"]-1) . ',';
  $T2C .='"type":"' . $incomingfrompost["type"] . '",';
  if ($incomingfrompost["title"]!="") $T2C .='"title":"' . $incomingfrompost["title"] . '",';
  if ($incomingfrompost["subtitle"]!="") $T2C .='"subtitle":"' . $incomingfrompost["subtitle"] . '",';
  if ($incomingfrompost["titlex"]!="") $T2C .='"titleX":"' . $incomingfrompost["titlex"] . '",';
  if ($incomingfrompost["titley"]!="") $T2C .='"titleY":"' . $incomingfrompost["titley"] . '",';
  $T2C .='"color":"' . $incomingfrompost["color"] . '",';
  $T2C .='"background":"' . $incomingfrompost["background"] . '",';
  $T2C .='"order":"' . $incomingfrompost["order"] . '",';
  $T2C .='"namecol":"' . $incomingfrompost["namecol"] . '",';
  $T2C .='"namerow":"' . $incomingfrompost["namerow"] . '",';
  if ($incomingfrompost["excludecols"]!="") $T2C .='"excludecols":"' . $incomingfrompost["excludecols"] . '",';
  if ($incomingfrompost["excluderows"]!="") $T2C .='"excluderows":"' . $incomingfrompost["excluderows"] . '",';
  if ($incomingfrompost["includecols"]!="") $T2C .='"includecols":"' . $incomingfrompost["includecols"] . '",';
  if ($incomingfrompost["includerows"]!="") $T2C .='"includerows":"' . $incomingfrompost["includerows"] . '",';
  $T2C .='"convert":' . (($incomingfrompost["convert"]=="true") ? "true" : "false");
  $T2C .='}' ;
  
  $T2C .="</script>\n"; 

  return $T2C;
}


}

?>